## qt-heif-image-plugin 0.3.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)  # lowest version tried

project(qtheifimageplugin)

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/imageformats")

add_subdirectory(src)

# vim:sw=2

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)  # lowest version tried

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# make release build, if not specified
# (from https://blog.kitware.com/cmake-and-the-default-build-type/)
set(default_build_type "RelWithDebInfo")

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE STRING "Build type" FORCE)
  set_property(
    CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif ()

# compiler flags
# TODO: separate GCC and Clang warnings; add more
set(
  CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} \
  -Wall \
  -Wextra \
  -Wshadow \
  -Wformat-nonliteral \
  -Wformat-security \
  -Wnon-virtual-dtor \
  ")

set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Og")

set(sanitizer_flags "-fsanitize=address -fsanitize=undefined")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${sanitizer_flags}")
set(CMAKE_MODULE_LINKER_FLAGS_DEBUG
    "${CMAKE_MODULE_LINKER_FLAGS_DEBUG} ${sanitizer_flags}")

#
# third-party libs
#

# qt
find_package(Qt5 COMPONENTS Core Gui REQUIRED)
add_definitions(-DQT_NO_KEYWORDS)
set(CMAKE_AUTOMOC ON)

# libheif
find_package(PkgConfig)
pkg_check_modules(libheif REQUIRED libheif>=1.1)

#
# project source
#

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(sources main.cpp qheifhandler.cpp)

add_library(qheif MODULE ${sources})

target_link_libraries(
  qheif
  PRIVATE
  Qt5::Gui
  ${libheif_LIBRARIES}
)

#
# installation
#

# Use qmake to find plugin dir (adapted from lxqt-qtplugin)
get_target_property(
  QT_QMAKE_EXECUTABLE ${Qt5Core_QMAKE_EXECUTABLE} IMPORTED_LOCATION)

if (NOT QT_QMAKE_EXECUTABLE)
  message(FATAL_ERROR "qmake is not found.")
endif ()

execute_process(
  COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_PLUGINS
  OUTPUT_VARIABLE QT_PLUGINS_DIR
  OUTPUT_STRIP_TRAILING_WHITESPACE)

if (QT_PLUGINS_DIR)
  message(STATUS "Qt5 plugin directory: " "${QT_PLUGINS_DIR}")
else ()
  message(FATAL_ERROR "Qt5 plugin directory cannot be detected.")
endif ()

# Prefix with DESTDIR if available to allow packaging
if (ENV{DESTDIR} AND NOT ENV{DESTDIR} STREQUAL "")
  set(plugins_dir "$ENV{DESTDIR}${QT_PLUGINS_DIR}")
else ()
  set(plugins_dir "${QT_PLUGINS_DIR}")
endif ()

install(
  TARGETS qheif
  LIBRARY DESTINATION "${plugins_dir}/imageformats")

# vim:sw=2

## qt-heif-image-plugin 0.3.3

=== debian/changelog ===
qt-heif-image-plugin (0.3.3-1~mx23) mx; urgency=medium

  * Rebuild for MX-23

 -- Timothy E. Harris <maintainer@mxrepo.com>  Tue, 11 Apr 2023 14:08:37 -0400

qt-heif-image-plugin (0.3.3-1~mx21+1) mx; urgency=medium

  * Rebuild for MX-21

 -- Timothy E. Harris <maintainer@mxrepo.com>  Fri, 18 Apr 2021 17:39:14 -0500

qt-heif-image-plugin (0.3.3-1~mx17+1) mx; urgency=medium

  * New upstream release.
    - Refactored for qtimageformats.
    - Removed usage of C++ exceptions.
    - Reduced libheif requirement to version 1.1.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 15 Mar 2019 17:22:47 -0700

qt-heif-image-plugin (0.3.2-1) unstable; urgency=medium

  * Fix reference
  * Don't use `qInfo()`
  * debian: Require cmake >= 3.5
  * debian: Build with more OS versions
  * Fix shadow warning

 -- Jake Harr <jakeharr@gmail.com>  Mon, 23 Jul 2018 17:26:30 -0400

qt-heif-image-plugin (0.3.1-1) unstable; urgency=medium

  * Avoid copying decoded data during read (#9)
  * Simplify decoded image movement (#9)
  * Document invariants
  * Refactor read state initialization (#10)
  * Add struct ctor for C++11 (#10)

 -- Jake Harr <jakeharr@gmail.com>  Sun, 22 Jul 2018 17:43:54 -0400

qt-heif-image-plugin (0.3.0-3) unstable; urgency=medium

  * debian/buildtool: Change versioning scheme (#2)

 -- Jake Harr <jakeharr@gmail.com>  Thu, 19 Jul 2018 15:24:15 -0400

qt-heif-image-plugin (0.3.0-2) unstable; urgency=medium

  * debian: Reword description

 -- Jake Harr <jakeharr@gmail.com>  Wed, 18 Jul 2018 04:07:01 -0400

qt-heif-image-plugin (0.3.0-1) unstable; urgency=medium

  * Use ID list to jump between images (#6)
  * Log file type brand (#7)
  * Initialize closer to usage
  * Improve `loadContext()` doc
  * cmake: Move to src subdir
  * iohandler: Be consistent with header guards
  * contextwriter: Remove unnecessary constants
  * iohandler: Fail if libheif is inconsistent with top-level IDs
  * debian: Add pkg-config build dependency (#2)
  * debian: Change maintainer (#2)
  * debian: Build using git-buildpackage (#2)
  * Add changelog

 -- Jake Harr <jakeharr@gmail.com>  Wed, 18 Jul 2018 03:38:03 -0400

qt-heif-image-plugin (0.2.1-1) unstable; urgency=medium

  * cmake: Fix DESTDIR usage; make compatible with older cmake
  * Ignore build and temporary dirs
  * Add Dockerfile to build package
  * README: Clean up; add info
  * README: Add blurb about lack of metadata
  * README: Clarify lack of support for image sequences
  * Determine format more robustly
  * Fix checking ftyp brand for "heix"
  * README: Link to dumageview
  * cmake: Fix sanitizer flags for linker
  * Fix format test in `Plugin::capabilities`
  * Change local Vim settings for Qt style
  * Indent 4 spaces
  * Change brace-newline style
  * Don't shadow function name with parameter
  * Use uppercase names for enum values
  * iohandler: Rename source/destination variables
  * iohandler: Document ReadState somewhat
  * iohandler: Move deleted copy ctor/assignment to public section
  * plugin: Use default ctor/dtor
  * Remove util.h
  * Reduce libheif requirement to version 1.2
  * README: Add nomacs as an application
  * Fix include order
  * Remove unnecessary includes

 -- Jake Harr <jakeharr@gmail.com>  Fri, 13 Jul 2018 01:44:32 -0400

qt-heif-image-plugin (0.2-1) unstable; urgency=medium

  [ Xu Shaohua ]
  * Ignore deb object files
  * debian: Update project homepage

  [ Jake Harr ]
  * Fix giant memory leak
  * cmake: Add sanitizer flags
  * Remove redundant data copy; add checks
  * cmake: Require libheif 1.3
  * Change macro/namespace/lib names
  * Improve logging
  * Add write checks
  * Sort includes
  * debian: Require libheif >= 1.3
  * cmake: Use DESTDIR if available

 -- Jake Harr <jakeharr@gmail.com>  Tue, 26 Jun 2018 14:52:06 -0400

qt-heif-image-plugin (0.1-2) unstable; urgency=medium

  * Fixed header parse error

 -- Xu Shaohua <xushaohua2016@outlook.com>  Mon, 04 Jun 2018 20:08:18 +0800

qt-heif-image-plugin (0.1-1) unstable; urgency=medium

  * Initial release

 -- Xu Shaohua <xushaohua2016@outlook.com>  Mon, 04 Jun 2018 19:09:04 +0800

=== debian/control ===
Source: qt-heif-image-plugin
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Jake Harr <jakeharr@gmail.com>
Build-Depends: debhelper (>= 9),
    cmake (>= 3.5),
    libheif-dev (>= 1.1),
    pkg-config,
    qtbase5-dev
Standards-Version: 3.9.8
Section: libs
Homepage: https://github.com/jakar/qt-heif-image-plugin

Package: qt-heif-image-plugin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: qt-heifimageplugin
Replaces: qt-heifimageplugin
Description: Qt 5 Plugin for HEIF Images
 Wraps libheif to enable Qt 5 applications to support HEIF images.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

## qt-heif-image-plugin 0.3.4

=== debian/changelog ===
qt-heif-image-plugin (0.3.4-1~mx25) mx; urgency=medium

  * New(ish) upstream release
  * Build for MX-25

 -- Timothy E. Harris <maintainer@mxrepo.com>  Sat, 03 May 2025 12:44:56 -0400

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Priority: optional
 Maintainer: Steven Pusser <stevep@mxlinux.org>
 XSBC-Original-Maintainer: Jake Harr <jakeharr@gmail.com>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 12),
     cmake (>= 3.5),
     libheif-dev (>= 1.1),
     pkg-config,
-    qtbase5-dev
+    qt6-base-dev
 Standards-Version: 3.9.8
 Section: libs
 Homepage: https://github.com/jakar/qt-heif-image-plugin
